/****************************************************************************
 *   Copyright (C) 2004 by Jurij Ivastsuk-Kienbaum                          *
 *   jurij@device-image.de                                                  *
 *                                                                          *
 *   This program is free software; you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by   *
 *   the Free Software Foundation; either version 2 of the License,         *
 *   or (at your option) any later version.                                 *
 *   This program is distributed in the hope that it will be useful,        *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty            *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                *
 *   See the GNU General Public License for more details.                   *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to the Free Software Foundation,*
 *   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA            *
 ***************************************************************************/
#include <sys/types.h>
#include <unistd.h>

#include "safe_read.h"
#include <errno.h>
#ifndef errno
extern int errno;
#endif

#ifdef EINTR
# define IS_EINTR(x) ((x) == EINTR)
#else
# define IS_EINTR(x) 0
#endif


size_t safe_read(int fd, void *buf, size_t count)
{
  ssize_t result;

  do
  {
      result = read(fd, buf, count);
  }
  while (result < 0 && IS_EINTR (errno));


  return (size_t)result;
}
